/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

//Initialize Global Variables

delayTime = [3.156, 3.156, 3.156, 3.156]; //Set default to register default value

delayTime_Used = 0; //Set defaut to 0, will get overwritten

is20Bit = -1; //default to unused value in case of error
isSPI = -1; //default to unused value in case of error

numSamplesCollected = 0;

const PLOT_XAXIS        = 0b10000000;
const PLOT_YAXIS        = 0b01000000;
const PLOT_ZAXIS        = 0b00100000;
const PLOT_TEMP         = 0b00010000;
const PLOT_ANGLE        = 0b00001000;
const PLOT_MAGNITUDE    = 0b00000100;
const PLOT_AFE_STATUS   = 0b00000010;
const PLOT_SYS_STATUS   = 0b00000001;

let toggleLEDcur = 0;
let toggleLEDprev = 0;
let toggleLEDstate = 0;
let pushThresh = 90;



let checkMagnitude = function(magAngle,version)
{
    let myRange = 0;
    if(magAngle == 1)//XY
    {
        
        if(adcrange[0] == adcrange[1])//x = y
        {
            myRange = adcrange[0];
            result = 'Range = ±' + myRange +' mT';
        }
        else
        {
             result = 'WARNING: X & Y ranges should be the same.';
        }
    }
    else if(magAngle == 2)//YZ
    {
        if(adcrange[1] == adcrange[2])//y = z
        {
            myRange = adcrange[1];
            result = 'Range = ±' + myRange +' mT';
        }
        else
        {
            result = 'WARNING: Y & Z ranges should be the same.';
        }
    }
    else if(magAngle == 3)//ZX
    {
        if(adcrange[0] == adcrange[2])//x = z
        {
            myRange = adcrange[0];
            result = 'Range = ±' + myRange +' mT';
        }
        else
        {
             result = 'WARNING: Z & X ranges should be the same.';
        }
    }
    else 
    {
        result = 'No Angle/Magnitude Calculation';
        //templateObj.$.ti_widget_label_rpad.label = 'Device Angle: -----';
    }
   
    templateObj.$.ti_widget_labelM.label= result;
    
    return 0;
};

let saveText = function(fname, text) {
    let blob = new Blob(['\ufeff' + text], {  //'\ufeff' added for excel printout when using special characters
        type: 'text/csv;charset=utf-8'
    });
    saveAs(blob, fname);

    return false;
};

function isEmptyOrSpaces(str)
{
    return str === null || (/^\s*$/).test(str);
}

function roundTo(n, digits) 
{
    if (digits === undefined) {
        digits = 0;
    }

    var multiplicator = Math.pow(10, digits);
    n = parseFloat((n * multiplicator).toFixed(11));
    return Math.round(n) / multiplicator;
}

function savePlots(plotFlags, fileName)
{
    let numEVMs = 1;//templateObj.$.ti_widget_droplist_numEVMs.selectedValue;
    let strDataArray = [];
    let result = "Sample";
    
    if (plotFlags & PLOT_XAXIS)
    {
        result = result + ", X AXIS Results (mT)";
        strDataArray.push(templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values);
        
    }
    
    if (plotFlags & PLOT_YAXIS)
    {
        result = result + ", Y AXIS Results (mT)";
        strDataArray.push(templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_values);
        
    }
    
    if (plotFlags & PLOT_ZAXIS)
    {
        result = result + ", Z AXIS Results (mT)";
        strDataArray.push(templateObj.$.ti_widget_scalargraph_MAGFIELD.series_2_values);
        
    }
    
    if (plotFlags & PLOT_TEMP)
    {
        let units;
        if(templateObj.$.ti_widget_droplist_dietemp_unit.selectedValue === 2)
        {
            units = " (°F)";
        }
        else
        {
            units = " (°C)";
        }
        result = result + ", Temperature Results" + units;
        strDataArray.push(templateObj.$.ti_widget_scalargraph_DIETEMP.series_0_values);
        
    }
    
    if (plotFlags & PLOT_ANGLE)
    {
        result = result + ", Angle Results (°)";
        strDataArray.push(templateObj.$.ti_widget_scalargraph_ANGLE.series_0_values);
        
    }
    
    if (plotFlags & PLOT_MAGNITUDE)
    {
        result = result + ", Magnitude Results (mT)";
        strDataArray.push(templateObj.$.ti_widget_scalargraph_MAGNITUDE.series_0_values);
        
    }
   
    result = result + "\n";
    
    for (let i = 0; i < strDataArray[0].length; i++)
    {
        result = result + i;
        
        for (let j = 0; j < strDataArray.length; j++) 
        {
            result = result + "," + strDataArray[j][i];
        }
        result = result + "\n";
    }
    
    saveText(fileName, result);
}


/*
*  Boilerplate code for creating computed data bindings
*/
document.addEventListener('gc-databind-ready', function() 
{
    /* 
	*   Add custom computed value databindings here, using the following method:
	*
    *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
	*
	*   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
	*   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
	*   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
    */
	
	// For example, a simple computed values based on simple expression
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable == 1 ? 'binding is one' : 'binding is not one'");
	
	// Or a custom two-way binding with custome getter and setter functions.  (setter is optional)  (getter only indicates one-way binding)
	// gc.databind.registry.bind('widget.id.propertyName', "targetVariable", function(value) { return value*5/9 + 32; }, function(value) { (return value-32)*9/5; });
	
	// Event 1 to n bindings
	/* 
    gc.databind.registry.bind('widget.date.value', 
        // dependant bindings needed in order to compute the date, in name/value pairs.
        {
            weekday: 'widget.dayOfWeek.selectedText',
            day: 'widget.dayOfMonth.value',
            month: 'widget.month.selectedText',
            year: 'widget.year.value'
        }, 
        // getter for date computation
        function(values) 
        {
            // compute and return the string value to bind to the widget with id 'date'
            return values.weekday + ', ' + values.month + ' ' + values.day + ', ' + values.year;
        }
    ); 
	*/
	
	//bind results registers to plots
    // gc.databind.registry.bind('widget.ti_widget_scalargraph_MAGFIELD.value_0', 'ti_model_register.x_ch_result_register.x_ch_result',
    //     function(value) 
    //     {
    //         let result = value;
    //         return result;
    //     }
    // ); 
    // gc.databind.registry.bind('widget.ti_widget_scalargraph_MAGFIELD.value_1', 'ti_model_register.y_ch_result_register.y_ch_result_register',
    //     function(value) 
    //     {
    //         let result = value;
    //         return result;
    //     }
    // ); 
    // gc.databind.registry.bind('widget.ti_widget_scalargraph_MAGFIELD.value_2', 'ti_model_register.z_ch_result_register.z_ch_result_register',
    //     function(value) 
    //     {
    //         let result = value;
    //         return result;
    //     }
    // ); 
    // gc.databind.registry.bind('widget.ti_widget_scalargraph_DIETEMP.value_0', 'ti_model_register.temp_result_register.temp_result',
    //     function(value) 
    //     {
    //         let result = value;
    //         return result;
    //     }
    // ); 
    // gc.databind.registry.bind('widget.ti_widget_scalargraph_MAGNITUDE.value_0', 'ti_model_register.magnitude_result_register.magnitude_result',
    //     function(value) 
    //     {
    //         let result = value;
    //         return result;
    //     }
    // ); 
   
    // gc.databind.registry.bind('widget.ti_widget_scalargraph_ANGLE.value_0', 'ti_model_register.angle_result_register.angle_result',
    //     function(value) 
    //     {
    //         let result = value;
    //         return result;
    //     }
    //  ); 
    gc.databind.registry.bind('widget.ti_widget_container_FIELD.visible',
    {
        X: 'widget.ti_widget_checkbox_XAXIS.checked',
        Y: 'widget.ti_widget_checkbox_YAXIS.checked',
        Z: 'widget.ti_widget_checkbox_ZAXIS.checked',
    },
        function(values)
        {
            return values.X||values.Y||values.Z;
        }
    );
    
    gc.databind.registry.bind('widget.ti_widget_scalargraph_MAGFIELD.numChannels',
    {
        X: 'widget.ti_widget_checkbox_XAXIS.checked',
        Y: 'widget.ti_widget_checkbox_YAXIS.checked',
        Z: 'widget.ti_widget_checkbox_ZAXIS.checked',
    },
        function(values)
        {
            let count = 0;
            if(!initplot)
            {
                if(values.X)
                {
                    if(CHX > -1)
                    {
                        templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values = Ch0hold;
                        templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "X-Component";
                        templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_color = "#00BBCC";
                        count++;
                    }
                }
                if (values.Y)
                {
                    if(CHY > -1)
                    {
                        if(count ==0 && CHY == 0)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values = Ch0hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "Y-Component";
                             templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_color = "#00BBCC";
                        }
                        else if(count ==0 && CHY == 1)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values = Ch1hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "Y-Component";
                             templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_color = "#115566";
                        }
                        else if(count ==1 && CHY == 1)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_values = Ch1hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_label = "Y-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_color = "#115566";
                        }
                        count++;
                    }
                }
                if (values.Z)
                {
                    if(CHZ > -1)
                    {
                        if(count ==0 && CHZ == 0)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values = Ch0hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "Z-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_color = "#00BBCC";
                        }
                        else if(count ==0 && CHZ == 1)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values = Ch1hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "Z-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_color = "#115566";
                        }
                        else if(count ==1 && CHZ == 1)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_values = Ch1hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_label = "Z-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_color = "#115566";
                        }
                        else if(count ==0 && CHZ == 2)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values = Ch2hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "Z-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_color = "#AAAAAA";
                        }
                        else if(count ==1 && CHZ == 2)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_values = Ch2hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_label = "Z-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_color = "#AAAAAA";
                        }
                        else if(count ==2 && CHZ == 2)
                        {
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_2_values = Ch2hold;
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_2_label = "Z-Component";
                            templateObj.$.ti_widget_scalargraph_MAGFIELD.series_2_color = "#AAAAAA";
                        }
                        count++;
                    }
                }
                return count;
            }
            else
            {
                count = 3;
                templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_label = "X-Component";
                templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_label = "Y-Component";
                templateObj.$.ti_widget_scalargraph_MAGFIELD.series_2_label = "Z-Component";
                initplot = false;
                return count;
            }
        }
    );

    gc.databind.registry.bind('widget.ti_widget_scalargraph_ANGLE.titleLabel',
    {
        angle:'ti_model_register.sensor_config_register.angle_en',
    },
        function(values)
        {
            if (values.angle == 2){return "YZ Angle Result";}
            else if (values.angle == 1){return "XY Angle Result";}
            else if (values.angle == 3){return "XZ Angle Result";}
            else {return "Angle Result"}
        }
    );
    
    gc.databind.registry.bind('widget.ti_widget_scalargraph_MAGNITUDE.titleLabel',
    {
        angle:'ti_model_register.sensor_config_register.angle_en',
    },
        function(values)
        {
            if (values.angle == 2){return "YZ Magnitude Result";}
            else if (values.angle == 1){return "XY Magnitude Result";}
            else if (values.angle == 3){return "XZ Magnitude Result";}
            else {return "Magnitude Result"}
        }
    );
    
    gc.databind.registry.bind('widget.ti_widget_label_calcangle.label',
    {
        x: 'ti_model_register.x_ch_result_register.x_ch_result',
        y: 'ti_model_register.y_ch_result_register.y_ch_result',
        mode: 'ti_model_register.sensor_config_register.angle_en',
    },
        function(values)
        {
        let calc = 0.00;
        let xData;
        let yData;
        let angle;
       
        let maxVal = 32767;
        let minVal = -32768;
       
        if(values.x > maxVal)
        {
            xData = values.x - 0x10000;
            xData = -xData*adcrange[0]/minVal;
        }
        else
        {
            xData = values.x*adcrange[0]/maxVal;
        }
        
        if(values.y > maxVal)
        {
            yData = values.y - 0x10000;
            yData = -yData*adcrange[1]/minVal;
        }
        else
        {
            yData = values.y*adcrange[1]/maxVal;
        }
        
        angle = Math.atan2(yData,xData)*180/Math.PI;
        if (angle < 0){angle = angle+360;}
        if (values.mode == 1){calc = angle;}
        
        
        toggleLEDprev = toggleLEDcur;
        if (!isNaN(parseFloat(pushThresh)) && isFinite(pushThresh))
        {
             if(xData > pushThresh | yData > pushThresh | xData < -pushThresh | yData < -pushThresh)
            {
                result = 1;
                toggleLEDcur = 1;
            }
            else
            {
                result = 0;
                toggleLEDcur = 0;
            }
            
            if ((toggleLEDcur != toggleLEDprev) & toggleLEDcur == 1)
            {
                if (toggleLEDstate == 1)
                {
                    templateObj.$.ti_tile_led1.value = 0;
                    toggleLEDstate = 0;
                }
                else 
                {
                    templateObj.$.ti_tile_led1.value = 1;
                    toggleLEDstate = 1;
                }
            }
        }
        templateObj.$.ti_tile_led.value = result;
        templateObj.$.ti_widget_angledisplay.value = calc;
        
        //TODO: 2D&3D plot.  
        // var set0 = {
        //         x: [xData],
        //         y: [yData],
        // };
       
        // var data = [set0];
        
        // Plotly.plot(templateObj.$.ti_widget_plot_2D.$.plot, data);  
        
       
    //     templateObj.$.ti_widget_plot_2D.data = [set0];
    //     plotly.plot(data, graphOptions, function (err, msg) {
    //     console.log(msg);
        
        return "Calculated Angle: " + (calc).toFixed(2) + "°";
        }
        
    );
    
    // gc.databind.registry.bind('widget.ti_widget_plot_2D.data',
    // {
    //     x: 'ti_model_register.x_ch_result_register.x_ch_result',
    //     y: 'ti_model_register.y_ch_result_register.y_ch_result',
    // },
    //     function(values)
    //     {
    //         Plotly.scatter(templateObj.$.ti_widget_plot_2D.$.plot, values);
    //         Plotly.scatter.show();
    //     }
    // );
    
    gc.databind.registry.bind('widget.ti_widget_label_deviceangle.label',
    {
       data: 'ti_model_register.angle_result_register.angle_result',
    },
        function(values)
        {
            let fraction = values.data & 0xF;
			let angle = values.data >> 4;
			angle = angle + fraction/16;
            
            return "Device Angle: " + (angle).toFixed(2) + "°";
        }
    );

    gc.databind.registry.bind('widget.ti_widget_numberbox_collect_delay.value',
    {
        avg: 'ti_model_register.device_config_register.conv_avg_num',
        op: 'ti_model_register.device_config_register.operating_mode',
        config: 'ti_model_register.sensor_config_register.mag_ch_en',
        sleep: 'ti_model_register.sensor_config_register.sleeptime',
        //added to update values when changing EVMs
        //autoDelay: 'ti_widget_checkbox_autodelay.checked',  //taken care of in event listeners due to issues here
    },
        function(values)
        {
            let delay;
            let conversionTimes = [45, 25];//us
            let averages = [1, 2, 4, 8, 16, 32];
            let wake = [1 , 5, 10, 15, 20, 30, 50, 100, 500, 1000];//ms
            let channels = [0, 1, 1, 2, 1, 2, 2, 3, 3, 3, 3, 3, 3, 3, 5, 6];
            
            let calcDelay = 0;
            
            // if(!values.autoDelay) //not needed so that we can track the values even when not using them
            // {
            //     return templateObj.$.ti_widget_numberbox_collect_delay.value;
            // }
            if (values.config > 0 )
            {
            calcDelay += ((channels[values.config]*averages[values.avg]-1)*conversionTimes[1]+conversionTimes[0])/1e3; // ((Conversions*Averages)-1)*25us + 45 us
            if (values.op == 0x4)//if Wake and sleep mode
                calcDelay += wake[values.sleep];//add Wake and Sleep interval
            }
            
            delay = calcDelay;
            
            delayTime_Used = delay*1.05;//5% buffer
            
            if (delayTime_Used < .05) {delayTime_Used = .05;}
            
            if (values.op === 0x00)
            {
                templateObj.$.ti_widget_label_Config.visible = true;
                templateObj.$.ti_widget_label_Config.label = "Configuration Mode: Set device to Active for maximum data rate";
                
                templateObj.$.ti_widget_checkbox_autodelay.visible = false;//force autodelay
                return 5; //set to fixed 5ms sample rate
                
            }
            else
            {
                 templateObj.$.ti_widget_checkbox_autodelay.visible = true;
                 templateObj.$.ti_widget_label_Config.visible = false;
            }
            
            
             if (templateObj.$.ti_widget_checkbox_autodelay.checked && delayTime_Used != templateObj.$.ti_widget_numberbox_collect_delay.value)
             {
                 Utilities.fireEvent('update-delay', Math.round(delayTime_Used*1000), "plots.js");//Convert to ms
             }
            
             if(!templateObj.$.ti_widget_checkbox_autodelay.checked)
             {
                 return templateObj.$.ti_widget_numberbox_collect_delay.value;
             }

            return delayTime_Used;
	    }
    );
    

    //Change Listeners 
    
    gc.databind.registry.bind('widget.ti_widget_labelX.label',
        // dependant bindings needed
        {
            range: 'ti_model_register.sensor_config_register.x_range',
            version: 'ti_model_register.test_config_register.ver',
            magAngle: 'ti_model_register.sensor_config_register.angle_en'
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let range;
            
            if(values.version == 1)//A2
            {
                if(values.range == 2)
                {
                    result = 'X Range = ±300 mT';
                    range = 300;
                }
                else if (values.range == 1)
                {
                    result = 'X Range = ±75 mT';
                    range = 133;
                }
                else
                {
                    result = 'X Range = ±150 mT';
                    range = 200;
                }
            }
            else//A1
            {
                if(values.range == 2)
                {
                    result = 'X Range = ±100 mT';
                    range = 100;
                }
                else if (values.range == 1)
                {
                    result = 'X Range = ±25 mT';
                    range = 25;
                }
                else
                {
                    result = 'X Range = ±50 mT';
                    range = 50;
                }
            }
            
            adcrange[0] = range;
            
            checkMagnitude(values.magAngle);
            
            return result;
        }
    ); 
    gc.databind.registry.bind('widget.ti_widget_labelY.label',
        // dependant bindings needed
        {
            range: 'ti_model_register.sensor_config_register.y_range',
            version: 'ti_model_register.test_config_register.ver',
            magAngle: 'ti_model_register.sensor_config_register.angle_en'
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let range;
            
            if(values.version == 1)//A2
            {
                if(values.range == 2)
                {
                    result = 'Y Range = ±300 mT';
                    range = 300;
                }
                else if (values.range == 1)
                {
                    result = 'Y Range = ±75 mT';
                    range = 133;
                }
                else
                {
                    result = 'Y Range = ±150 mT';
                    range = 200;
                }
            }
            else//A1
            {
                if(values.range == 2)
                {
                    result = 'Y Range = ±100 mT';
                    range = 100;
                }
                else if (values.range == 1)
                {
                    result = 'Y Range = ±25 mT';
                    range = 25;
                }
                else
                {
                    result = 'Y Range = ±50 mT';
                    range = 50;
                }
            }
            
            adcrange[1] = range;
            
            checkMagnitude(values.magAngle, values.version);
            
            return result;
        }
    ); 
    gc.databind.registry.bind('widget.ti_widget_labelZ.label',
        // dependant bindings needed
        {
            range: 'ti_model_register.sensor_config_register.z_range',
            version: 'ti_model_register.test_config_register.ver',
            magAngle: 'ti_model_register.sensor_config_register.angle_en'
        },
        // getter for date computation
        function(values) 
        {
            let result;
            let range;
            
            if(values.version == 1)//A2
            {
                if(values.range == 2)
                {
                    result = 'Z Range = ±300 mT';
                    range = 300;
                }
                else if (values.range == 1)
                {
                    result = 'Z Range = ±75 mT';
                    range = 133;
                }
                else
                {
                    result = 'Z Range = ±150 mT';
                    range = 200;
                }
            }
            else//A1
            {
                if(values.range == 2)
                {
                    result = 'Z Range = ±100 mT';
                    range = 100;
                }
                else if (values.range == 1)
                {
                    result = 'Z Range = ±25 mT';
                    range = 25;
                }
                else
                {
                    result = 'Z Range = ±50 mT';
                    range = 50;
                }
            }
            
            adcrange[2] = range;
            
            checkMagnitude(values.magAngle,values.version);
            
            return result;
        }
    ); 
    // gc.databind.registry.getBinding('widget.ti_model_register.$selectedDevice').addChangedListener(  //done in scbCustomCodec
    // {
    //     onValueChanged: function(oldValue, newValue)
    //     {
    //         if(newValue === "INA229" || newValue === "INA239")
    //         {
    //             isSPI = true;
    //         }
    //         else
    //         {
    //             isSPI = false;
    //         }
    //         if(newValue === "INA229" || newValue === "INA228")
    //         {
    //             is20Bit = true;
    //         }
    //         else
    //         {
    //             is20Bit = false;
    //         }
    //  	}
    // });
    
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_selectedEVM.selectedValue').addChangedListener(
    // {
    //     onValueChanged: function(oldValue, newValue)
    //     {
    //         Utilities.fireEvent('select-evm', templateObj.$.ti_widget_droplist_selectedEVM.selectedValue, "plots.js");
    //  	}
    // });
    
    // const swE1 = {
    //     onValueChanged: function() {
    //         data[0].sw0 = templateObj.$.ti_widget_droplist_E1_SW0.selectedValue;
    //         data[0].sw1 = templateObj.$.ti_widget_droplist_E1_SW1.selectedValue;
    //         if(selectedEVM === 0)
    //         {
    //             templateObj.$.ti_widget_droplist_config_SW0.selectedValue = data[0].sw0;
    //             templateObj.$.ti_widget_droplist_config_SW1.selectedValue = data[0].sw1;
    //         }
    //         templateObj.$.ti_widget_droplist_selectedEVM.selectedValue = 0;
    //         Utilities.fireEvent('select-evm', templateObj.$.ti_widget_droplist_selectedEVM.selectedValue, "plots.js");
    //     }
    // };
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E1_SW0.selectedValue').addChangedListener(swE1);
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E1_SW1.selectedValue').addChangedListener(swE1);
    
    // const swE2 = {
    //     onValueChanged: function() {
    //         data[1].sw0 = templateObj.$.ti_widget_droplist_E2_SW0.selectedValue;
    //         data[1].sw1 = templateObj.$.ti_widget_droplist_E2_SW1.selectedValue;
    //         templateObj.$.ti_widget_droplist_selectedEVM.selectedValue = 1;
    //         if(selectedEVM === 1)
    //         {
    //             templateObj.$.ti_widget_droplist_config_SW0.selectedValue = data[1].sw0;
    //             templateObj.$.ti_widget_droplist_config_SW1.selectedValue = data[1].sw1;
    //         }
    //         Utilities.fireEvent('select-evm', templateObj.$.ti_widget_droplist_selectedEVM.selectedValue, "plots.js");
    //     }
    // };
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E2_SW0.selectedValue').addChangedListener(swE2);
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E2_SW1.selectedValue').addChangedListener(swE2);
    
    // const swE3 = {
    //     onValueChanged: function() {
    //         data[2].sw0 = templateObj.$.ti_widget_droplist_E3_SW0.selectedValue;
    //         data[2].sw1 = templateObj.$.ti_widget_droplist_E3_SW1.selectedValue;
    //         templateObj.$.ti_widget_droplist_selectedEVM.selectedValue = 2;
    //         if(selectedEVM === 2)
    //         {
    //             templateObj.$.ti_widget_droplist_config_SW0.selectedValue = data[2].sw0;
    //             templateObj.$.ti_widget_droplist_config_SW1.selectedValue = data[2].sw1;
    //         }
    //         Utilities.fireEvent('select-evm', templateObj.$.ti_widget_droplist_selectedEVM.selectedValue, "plots.js");
    //     }
    // };
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E3_SW0.selectedValue').addChangedListener(swE3);
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E3_SW1.selectedValue').addChangedListener(swE3);
    
    // const swE4 = {
    //     onValueChanged: function() {
    //         data[3].sw0 = templateObj.$.ti_widget_droplist_E4_SW0.selectedValue;
    //         data[3].sw1 = templateObj.$.ti_widget_droplist_E4_SW1.selectedValue;
    //         templateObj.$.ti_widget_droplist_selectedEVM.selectedValue = 3;
    //         if(selectedEVM === 3)
    //         {
    //             templateObj.$.ti_widget_droplist_config_SW0.selectedValue = data[3].sw0;
    //             templateObj.$.ti_widget_droplist_config_SW1.selectedValue = data[3].sw1;
    //         }
    //         Utilities.fireEvent('select-evm', templateObj.$.ti_widget_droplist_selectedEVM.selectedValue, "plots.js");
    //     }
    // };
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E4_SW0.selectedValue').addChangedListener(swE4);
    // gc.databind.registry.getBinding('widget.ti_widget_droplist_E4_SW1.selectedValue').addChangedListener(swE4);
    
            
    // let myBinding = gc.databind.registry.getBinding('widget.ti_widget_numberbox_collect_delay.value');
    // myBinding.addChangedListener(
    //  {
    //      onValueChanged: function(oldValue, newValue)
    //      {
    //          if(templateObj.$.ti_widget_checkbox_autodelay.checked)
    //          {
    //              this.fire('update-delay', Math.round(newValue*1000));
    //          }
    //      }
    //  });

    //  gc.databind.registry.getBinding('widget.ti_widget_numberbox_collect_delay.value').addChangedListener(
    //  {
    //      onValueChanged: function(oldValue, newValue)
    //      {
    //          if(templateObj.$.ti_widget_checkbox_autodelay.checked)
    //          {
    //              this.fire('update-delay', Math.round(newValue*1000));
    //          }
    //      }
    //  });
	
});



/*
*  Boilerplate code for creating custom actions
*/
document.addEventListener('gc-nav-ready', function() 
{
    /* 
	*   Add custom actions for menu items using the following api:
	*
    *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
	*
	*   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
	*   param runable - function that performs the custom action.
	*   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
	*   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
    */
	
	// For example,
	// gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });
	
	// Alternatively, to programmatically disable a menu action at any time use:
	// gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction'); 
});

/*
*  Boilerplate code for working with components in the application gist
*/
/**/

var initComplete = false;
//var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
  	        // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId
  	        
            templateObj.$.ti_widget_button_clear_FIELD.addEventListener("click", function(event) {
                this.fire('clear-magfield');
            });
            templateObj.$.ti_widget_button_save_FIELD.addEventListener("click", function (event) 
            {
                savePlots(PLOT_XAXIS, "MAGFIELDX_Results.csv");
                savePlots(PLOT_YAXIS, "MAGFIELDY_Results.csv");
                savePlots(PLOT_ZAXIS, "MAGFIELDZ_Results.csv");
            });
   
            templateObj.$.ti_widget_button_clear_DIETEMP.addEventListener("click", function(event) {
                this.fire('clear-dietemp');
            });
            templateObj.$.ti_widget_button_save_DIETEMP.addEventListener("click", function (event) 
            {
                savePlots(PLOT_TEMP, "DIETEMP_Results.csv");
            });
    
            templateObj.$.ti_widget_button_clear_ANGLE.addEventListener("click", function(event) {
                this.fire('clear-angle');
            });
            templateObj.$.ti_widget_button_save_ANGLE.addEventListener("click", function (event) 
            {
                savePlots(PLOT_ANGLE, "ANGLE_Results.csv");
            });
            
            templateObj.$.ti_widget_button_clear_MAG.addEventListener("click", function(event) {
                this.fire('clear-magnitude');
            });
            templateObj.$.ti_widget_button_save_MAG.addEventListener("click", function (event) 
            {
                savePlots(PLOT_MAGNITUDE, "MAGNITUDE_Results.csv");
            });
            
            templateObj.$.ti_widget_button_clear_all.addEventListener("click", function(event) {
                this.fire('clear-all-plots');
                numSamplesCollected = 0;
            });
            templateObj.$.ti_widget_numberbox_samples_all.addEventListener("changed", function(event) {
                numSamplesCollected = 0;
            });
            
            templateObj.$.ti_widget_button_save_all.addEventListener("click", function (event) 
            {
                let plotFlags = 0;
                
                plotFlags |= templateObj.$.ti_widget_checkbox_XAXIS.checked ? 1 : 0;
                plotFlags <<= 1;
                plotFlags |= templateObj.$.ti_widget_checkbox_YAXIS.checked ? 1 : 0;
                plotFlags <<= 1;
                plotFlags |= templateObj.$.ti_widget_checkbox_ZAXIS.checked ? 1 : 0;
                plotFlags <<= 1;
                plotFlags |= templateObj.$.ti_widget_checkbox_DIETEMP.checked ? 1 : 0;
                plotFlags <<= 1;
                plotFlags |= templateObj.$.ti_widget_checkbox_ANGLE.checked ? 1 : 0;
                plotFlags <<= 1;
                plotFlags |= templateObj.$.ti_widget_checkbox_MAGNITUDE.checked ? 1 : 0;
                plotFlags <<= 1;
                plotFlags <<= 2; // For AFE and SYS status
                
                savePlots(plotFlags, "All_Results.csv");
            });
            
            templateObj.$.ti_widget_button_collect_start.addEventListener("click", function(event) {
                templateObj.$.ti_widget_register_page.autoReadValue = -1;
                
                this.fire('collect-data-plus');
            });
            templateObj.$.ti_widget_button_collect_stop.addEventListener("click", function(event) {
                this.fire('abort-collect');
                
            });
            templateObj.$.ti_widget_checkbox_autodelay.addEventListener("changed", function(event) {
                if(templateObj.$.ti_widget_checkbox_autodelay.checked)
                {
                    templateObj.$.ti_widget_numberbox_collect_delay.value = delayTime_Used;
                    this.fire('update-delay', Math.round(delayTime_Used*1000));
                }
            });
            templateObj.$.ti_widget_numberbox_collect_delay.addEventListener("changed", function(event) {
                this.fire('update-delay', Math.round(templateObj.$.ti_widget_numberbox_collect_delay.value*1000));
            });
            
            templateObj.$.ti_widget_checkbox_FIELD_manual.addEventListener("changed", function(event) {
                if(templateObj.$.ti_widget_checkbox_FIELD_manual.checked)
                {
                    let numaxes = 0;
                    if(templateObj.$.ti_widget_checkbox_XAXIS.checked){numaxes++;}
                    if(templateObj.$.ti_widget_checkbox_YAXIS.checked){numaxes++;}
                    if(templateObj.$.ti_widget_checkbox_ZAXIS.checked){numaxes++;}
                    templateObj.$.ti_widget_scalargraph_MAGFIELD.numChannels = numaxes;
                    
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_FIELDMax.value))
                    {
                        let max
                        let maxTemp
                        max = templateObj.$.ti_widget_scalargraph_MAGFIELD.series_0_values.reduce(function(a,b){return Math.max(a, b);});
                        if(numaxes > 1)
                        {
                            maxTemp = templateObj.$.ti_widget_scalargraph_MAGFIELD.series_1_values.reduce(function(a,b){return Math.max(a, b);});
                            max = Math.max(max, maxTemp);
                        }
                        if(numaxes > 2)
                        {
                            maxTemp = templateObj.$.ti_widget_scalargraph_MAGFIELD.series_2_values.reduce(function(a,b){return Math.max(a, b);});
                            max = Math.max(max, maxTemp);
                        }
                        
                        templateObj.$.ti_widget_textbox_MAGMax.value = max;
                    }
                }
            });
            
            templateObj.$.ti_widget_checkbox_dietemp_manual.addEventListener("changed", function(event) {
                if(templateObj.$.ti_widget_checkbox_dietemp_manual.checked)
                {
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_dietempMax.value))
                    {
                        let max
                        max = templateObj.$.ti_widget_scalargraph_DIETEMP.series_0_values.reduce(function(a,b){return Math.max(a, b);});
                        templateObj.$.ti_widget_textbox_dietempMax.value = max;
                    }
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_dietempMin.value))
                    {
                        let min
                        min = templateObj.$.ti_widget_scalargraph_DIETEMP.series_0_values.reduce(function(a,b){return Math.min(a, b);});
                        templateObj.$.ti_widget_textbox_dietempMin.value = min;
                    }
                }
            });
            templateObj.$.ti_widget_checkbox_ANGLE_manual.addEventListener("changed", function(event) {
                if(templateObj.$.ti_widget_checkbox_ANGLE_manual.checked)
                {
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_ANGLEMax.value))
                    {
                        let max
                        max = templateObj.$.ti_widget_scalargraph_ANGLE.series_0_values.reduce(function(a,b){return Math.max(a, b);});
                        templateObj.$.ti_widget_textbox_ANGLEMax.value = max;
                    }
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_ANGLEMin.value))
                    {
                        let min
                        min = templateObj.$.ti_widget_scalargraph_ANGLE.series_0_values.reduce(function(a,b){return Math.min(a, b);});
                        templateObj.$.ti_widget_textbox_ANGLEMin.value = min;
                    }
                }
            });
            templateObj.$.ti_widget_checkbox_MAG_manual.addEventListener("changed", function(event) {
                if(templateObj.$.ti_widget_checkbox_MAG_manual.checked)
                {
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_MAGMax.value))
                    {
                        let max
                        max = templateObj.$.ti_widget_scalargraph_MAGNITUDE.series_0_values.reduce(function(a,b){return Math.max(a, b);});
                        templateObj.$.ti_widget_textbox_MAGMax.value = max;
                    }
                    if(isEmptyOrSpaces(templateObj.$.ti_widget_textbox_MAGMin.value))
                    {
                        let min
                        min = templateObj.$.ti_widget_scalargraph_MAGNITUDE.series_0_values.reduce(function(a,b){return Math.min(a, b);});
                        templateObj.$.ti_widget_textbox_MAGMin.value = min;
                    }
                }
            });
            
             templateObj.$.ti_widget_textbox_threshold.addEventListener("changed", function (event) 
            {
                pushThresh = templateObj.$.ti_widget_textbox_threshold.value;
            });
       
            templateObj.$.ti_widget_droplist_dietemp_unit.addEventListener("selected", function(event) {
                let strData0Ref = templateObj.$.ti_widget_scalargraph_DIETEMP.series_0_values;
                let data0Last;
               
                //Convert data. Offset by one value so that we can force a visual update.
                if(ti_widget_droplist_dietemp_unit.selectedText == "°F")
                {
                    data0Last = (strData0Ref[strData0Ref.length-1] * (9/5)) + 32;
                   
                    for (let i = strData0Ref.length-2; i >= 0; i--) 
                    {
                        strData0Ref[i+1] = (strData0Ref[i] * (9/5)) + 32;
                        
                    }
                    //temporary values that will get pushed out of the arrays
                    strData0Ref[0] = (strData0Ref[0] * (9/5)) + 32;
                   
                }
                else
                {
                    data0Last = (strData0Ref[strData0Ref.length-1] - 32) * (5/9);
                   
                    for (let i = strData0Ref.length-2; i >= 0; i--)
                    {
                        strData0Ref[i+1] = (strData0Ref[i] - 32) * (5/9);
                       
                    }
                    //temporary values that will get pushed out of the arrays
                    strData0Ref[0] = (strData0Ref[0] - 32) * (5/9);
                   
                }
                
                //update scale
                if(templateObj.$.ti_widget_checkbox_dietemp_manual.checked)
                {
                    if(ti_widget_droplist_dietemp_unit.selectedValue === 2)
                    {
                        templateObj.$.ti_widget_textbox_dietempMax.value = roundTo((templateObj.$.ti_widget_textbox_dietempMax.value * (9/5)) + 32,13);
                        templateObj.$.ti_widget_textbox_dietempMin.value = roundTo((templateObj.$.ti_widget_textbox_dietempMin.value * (9/5)) + 32,13);
                    }
                    else
                    {
                        templateObj.$.ti_widget_textbox_dietempMax.value = roundTo((templateObj.$.ti_widget_textbox_dietempMax.value - 32) * (5/9),13);
                        templateObj.$.ti_widget_textbox_dietempMin.value = roundTo((templateObj.$.ti_widget_textbox_dietempMin.value - 32) * (5/9),13);
                    }
                }
                
                //put the last data sample in manally to force visual update
		        if(templateObj.$.ti_widget_scalargraph_DIETEMP.value_0 === data0Last)
			    {
			        templateObj.$.ti_widget_scalargraph_DIETEMP.value_0Changed();
			    }
			    else
			    {
			        templateObj.$.ti_widget_scalargraph_DIETEMP.value_0 = data0Last;
			    }
               
                changingUnits = 0;
            });
            
        },1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}


